// Debugger.cpp: implementation of the CDebugger class.
//
//////////////////////////////////////////////////////////////////////

/*******************************************************************************
 *                                                                             *
 *  This file is part of NotesAntiSpam.                                        *
 *                                                                             *
 *  NotesAntiSpam is free software; you can redistribute it and/or modify      *
 *  it under the terms of the GNU General Public License as published by       *
 *  the Free Software Foundation; either version 2 of the License, or          *
 *  (at your option) any later version.                                        *
 *                                                                             *
 *  NotesAntiSpam is distributed in the hope that it will be useful,           *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
 *  GNU General Public License for more details.                               *
 *                                                                             *
 *  You should have received a copy of the GNU General Public License          *
 *  along with NotesAntiSpam; if not, write to the Free Software               *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  *
 *                                                                             *
 *  Copyright (c) 2003 Thomas Kriener                                          *
 *                                                                             *
 *******************************************************************************/

#include "stdafx.h"
//#include "dispatcher.h"
#include "Debugger.h"

#include "fstream.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDebugger::CDebugger(const CString& filename)
{
	char    *pth;
	char    agentPath[256];
	int     n;

	// Build PATH
	if ((pth = getenv("TEMP")) == NULL)
		strcpy(agentPath, "\\");
	else
	{
		strcpy(agentPath, pth);
		if ((n = strlen(agentPath)) && (agentPath[--n] == '\\'))
			agentPath[n] = '\0';
	}

	m_logFile=agentPath;
	m_logFile+="\\";
	m_logFile+=filename;
}

CDebugger::~CDebugger()
{

}

void CDebugger::SetState(BOOL state)
{
	m_state=state;
}

/* Write Debug-Messages */
void CDebugger::Add(const CString& message)
{
	ofstream debugFile;
	CTime time = CTime::GetCurrentTime();;

	/* If Debug is switched off, do nothing */
	if(!m_state) return;

	/* Write Debug to File */
	debugFile.open(m_logFile,ios::app);
	debugFile<<time.Format("%d.%m.%Y %H:%M:%S ")<<message<<endl;
	debugFile.close();
}

BOOL CDebugger::GetState()
{
	return m_state;
}

void CDebugger::Reset()
{
	// Delete contents of debug-File
	ofstream debugFile;
	debugFile.open(m_logFile);
	debugFile.close();
}
