// DnsblCache.cpp: implementation of the CDnsblCache class.
//
//////////////////////////////////////////////////////////////////////

/*******************************************************************************
 *                                                                             *
 *  This file is part of NotesAntiSpam.                                        *
 *                                                                             *
 *  NotesAntiSpam is free software; you can redistribute it and/or modify      *
 *  it under the terms of the GNU General Public License as published by       *
 *  the Free Software Foundation; either version 2 of the License, or          *
 *  (at your option) any later version.                                        *
 *                                                                             *
 *  NotesAntiSpam is distributed in the hope that it will be useful,           *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
 *  GNU General Public License for more details.                               *
 *                                                                             *
 *  You should have received a copy of the GNU General Public License          *
 *  along with NotesAntiSpam; if not, write to the Free Software               *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  *
 *                                                                             *
 *  Copyright (c) 2003 Thomas Kriener                                          *
 *                                                                             *
 *******************************************************************************/

#include "stdafx.h"
#include "NotesAntiSpam.h"
#include "DnsblCache.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDnsblCache::CDnsblCache()
{

}

CDnsblCache::~CDnsblCache()
{

}

BOOL CDnsblCache::Check(const CIPAddress &ipAddress)
{
	for(int i=0;i<m_cache.GetSize();i++)
	{
		if(m_cache[i].m_ipAddress==ipAddress)
		{
			return TRUE;
		}
	}
	return FALSE;
}

void CDnsblCache::AddEntry(const CIPAddress &ipAddress, const CString &dnsbl)
{
	CDnsblCacheEntry entry;
	entry.m_ipAddress=ipAddress;
	entry.m_dnsbl=dnsbl;
	m_cache.Add(entry);
}

CString CDnsblCache::GetDnsbl4IPAddress(const CIPAddress &ipAddress)
{
	for(int i=0;i<m_cache.GetSize();i++)
	{
		if(m_cache[i].m_ipAddress==ipAddress)
		{
			return m_cache[i].m_dnsbl;
		}
	}
	return "";
}
