// SpamBayes.cpp: implementation of the CSpamBayes class.
//
//////////////////////////////////////////////////////////////////////
/*******************************************************************************
 *                                                                             *
 *  This file is part of NotesAntiSpam.                                        *
 *                                                                             *
 *  NotesAntiSpam is free software; you can redistribute it and/or modify      *
 *  it under the terms of the GNU General Public License as published by       *
 *  the Free Software Foundation; either version 2 of the License, or          *
 *  (at your option) any later version.                                        *
 *                                                                             *
 *  NotesAntiSpam is distributed in the hope that it will be useful,           *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
 *  GNU General Public License for more details.                               *
 *                                                                             *
 *  You should have received a copy of the GNU General Public License          *
 *  along with NotesAntiSpam; if not, write to the Free Software               *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  *
 *                                                                             *
 *  Copyright (c) 2003 Thomas Kriener                                          *
 *                                                                             *
 *******************************************************************************/

#include "stdafx.h"
#include "NotesAntiSpam.h"
#include "SpamBayes.h"
#include <boost/python.hpp>
using namespace boost::python;

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSpamBayes::CSpamBayes()
{
	 Py_Initialize();
}

CSpamBayes::~CSpamBayes()
{
	Py_Finalize();
}

BOOL CSpamBayes::CheckSpam(const CString &mail)
{
	if(!Py_IsInitialized())
		return false;

	handle<> main_module(borrowed( PyImport_AddModule("__main__") ));
	dict main_namespace=dict(handle<>(borrowed( PyModule_GetDict(main_module.get()) )));
	object result(handle<>( PyRun_String("5 ** 2", Py_eval_input,
	                        main_namespace.ptr(), main_namespace.ptr()) ));
    int five_squared = extract<int>(result);
	if(five_squared==25)
		return false;
	else
		return false;
}

BOOL CSpamBayes::TrainSpam(const CString &mail)
{
	if(!Py_IsInitialized())
		return false;
	handle<> main_module(borrowed( PyImport_AddModule("__main__") ));
	dict main_namespace=dict(handle<>(borrowed( PyModule_GetDict(main_module.get()) )));

	return false;
}

BOOL CSpamBayes::TrainHam(const CString &mail)
{
	if(!Py_IsInitialized())
		return false;
	handle<> main_module(borrowed( PyImport_AddModule("__main__") ));
	dict main_namespace=dict(handle<>(borrowed( PyModule_GetDict(main_module.get()) )));

	return false;
}
